/*******************************************************************************
 Comments v1.0 - 08/24/2006
 maleval@gawab.com
 Update (11/28/2007) : added hash comments #
 Update (10/22/2008) : bersetzung ins Deutsche von Frederic Ch.Reuter
 ------------------------------------------------------------------------------
Fgt HTML Kommentare als Multi-, oder Single- Line ein:
  Fgt einen HTML-Kommentar als Single- oder Multi-Line um eine Auswahl 
  herum ein. Haben Sie keine Auswahl gewhlt, wird der Kommentar an der 
  Cursorposition eingefgt. Fr die Single-Line-Kommentare werden zu Beginn
  einer jeden Zeile der Dopple-Slash eingefgt.

Entferne Kommenar-Tags:
  Suche in einer Markierung nach Kommentaren. Ist keine Markierung vorgenommen
  worden, sucht er in der aktuellen Zeile. Diese Funktion entfernt nur den 
  Kommentar-Verweis einer Zeile, nicht aber deren Inhalt (also nur den 
  Kommentar-tag am Beginn und am Ende)! 

Entferne alle Kommentar-Zeilen:  
  Groes Aufrumen! Entfernt alle gefundenen Kommentare, ausgenommen evtl.  
  vorhandener HTML-Kommentare.
  WARNUNG: Das kann sehr gefhrlich sein, abhngig davon, was in der Datei
  stand. Stellen Sie erst sicher, dass Sie ein Sicherung der hiermit zu 
  bearbeitenden Datei angefertigt haben - ein Rckschritt ist dann nicht 
  mehr mglich!  

Tested with PSPad 4.5.1 (2207) - Win XP SP2
Tested also with 4.5.3 (2298)  - Windows VISTA Home-Premium SP1
*******************************************************************************/

var module_name = "InsertComments_ger";
var module_ver = "1.0";

function insertHTMLComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var s = ceDoc.selText();
  s = "<!--"+s+"-->";
  ceDoc.selText(s);
}

function insertMultiLinesComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var s = ceDoc.selText();
  s = "/*"+s+"*/";
  ceDoc.selText(s);
}

function insertSingleLineComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var l, i, s;
  s = ceDoc.selText();
  var sArr = s.split("\n");
  for (i in sArr) {
    l = "//"+sArr[i];
    ceDoc.selText(l);
  }
}

function insertBashComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var l, i, s;
  s = ceDoc.selText();
  var sArr = s.split("\n");
  for (i in sArr) {
    l = "#"+sArr[i];
    ceDoc.selText(l);
  }
}

function removeCommentsTags(){
  var r, s, flag = false;;
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  s = ceDoc.selText();

  if (!s) {
    flag = true;
    s = ceDoc.lineText();
  }

  r = /<!--|-->|#|\/\*|\*\/|\/\//g;
  var res = s.search(r);

  if (res != -1) {
    s = s.replace(r, "");
    if (!flag) {
      ceDoc.selText(s);
    }
    else {
      ceDoc.lineText(s);
    }
  }
}

function removeAllComments(){
  var warning = "Hiermit werden ALLE Kommentarzeilen aus dem Dokument entfernt!\n "+
                "Sind Sie sicher, dass Sie das auch wirklich wollen?";

  if (confirm(warning)) {
    var r, s, x, y;
    var ceDoc = newEditor();
    ceDoc.assignActiveEditor();

    x = ceDoc.caretX();
    y = ceDoc.caretY();
    s = ceDoc.text();

    // Nettoyer commentaires ligne simple
    // Umsetzen einfacher Kommentarzeilen
    // Convertir avant les URL en http:/
    r = new RegExp("([a-z]+)://", "g");
    s = s.replace(r, "$1:/");

    // Commentaires ligne simple
    // Kommentieren einfacher Zeilen
    r = /\/\/.*/g;
    s = s.replace(r,"");

    // Conversion inverse pour les URL
    // Konvertieren inverser URLs
    r = new RegExp("([a-z]+):/", "g");
    s = s.replace(r, "$1://");

    // Commentaires multilignes
    //Konvertieren von Multi-Lines
    r = /\/\*[^\*\/]*\*\//g;
    s = s.replace(r,"");

    ceDoc.text(s);
    ceDoc.setCaretPos(x,y);
  }
}

function Init(){
  addMenuItem("HTML Kommentar einfgen <!-- --> ", "Kommentar", "insertHTMLComments");
  addMenuItem("Multi Lines Kommentar einfgen /* */", "Kommentar", "insertMultiLinesComments");
  addMenuItem("Single Line Kommentar einfgen //", "Kommentar", "insertSingleLineComments");
  addMenuItem("Single Line Kommentar einfgen #", "Kommentar", "insertBashComments");
  addMenuItem("-", "Kommentar", "");
  addMenuItem("Entferne Kommentar Tags", "Kommentar", "removeCommentsTags");
  addMenuItem("Entferne ALLE Kommentarzeilen", "Kommentar", "removeAllComments");
}

function confirm(text) {
  // Provided by gogogadgetscott
  // Untersttzt von gogogadgetscott 
  // http://forum.pspad.com/read.php?2,30707
  text = text ? text : "Sind Sie sicher ?";
  var ie = CreateObject("InternetExplorer.Application");
  ie.width = 0; ie.height = 0; ie.left = 10000000; ie.visible = true;

  ie.navigate("about:blank");

  var returnValue = ie.Document.parentWindow.confirm(text);
  ie.quit();
  return returnValue;
}